## kaidan 0.9.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
set(CMAKE_CXX_STANDARD 20)
set(QT_MIN_VERSION "5.15.0")
set(KF5_MIN_VERSION "5.67.0")

if(POLICY CMP0071)
	cmake_policy(SET CMP0071 NEW)
endif()

project(kaidan)

# application information
set(APPLICATION_ID "im.kaidan.kaidan")
set(APPLICATION_NAME "kaidan")
set(APPLICATION_DISPLAY_NAME "Kaidan")
set(APPLICATION_DESCRIPTION "User-friendly and modern chat app for every device")
if(UBUNTU_TOUCH)
	set(APPLICATION_NAME "${APPLICATION_ID}")
endif()

# Version
set(VERSION_MAJOR 0)
set(VERSION_MINOR 9)
set(VERSION_PATCH 1)
set(VERSION_CODE 14)
set(VERSION_EXTRA "" CACHE STRING "Stuff to append to version string")

set(DEVELOPMENT_BUILD FALSE)
if(DEVELOPMENT_BUILD)
	set(VERSION_EXTRA "${VERSION_EXTRA}-dev")
endif()

set(VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
if(VERSION_EXTRA)
	set(VERSION_STRING ${VERSION_STRING}${VERSION_EXTRA})
endif()

# CMake options
option(BUILD_TESTS "Build unit tests" FALSE)
option(STATIC_BUILD "Build Kaidan statically")
option(APPIMAGE "Build Kaidan as AppImage (will only work in the appimage script)" FALSE)
option(UBUNTU_TOUCH "Building an Ubuntu Touch click (internal use only!)" FALSE)
option(CLICK_ARCH "Architecture that will be used in the click's manifest")
option(CLICK_DATE "Date used in the version number in the click's manifest")
option(QUICK_COMPILER "Use QtQuick compiler to improve performance" FALSE)
option(USE_KNOTIFICATIONS "Use KNotifications for displaying notifications" TRUE)
option(BUNDLE_ICONS "Bundle breeze icons" FALSE)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Instruct CMake to run moc, uic and rcc automatically when needed.
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(AUTOMOC_MOC_OPTIONS -Muri=${APPLICATION_ID})

#
# Dependecies
#

find_package(ECM 5.40.0 REQUIRED NO_MODULE)

# CMake module path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

# CMake modules include
include(KDEInstallDirs)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)
include(ECMInstallIcons)
include(FeatureSummary)
kde_enable_exceptions()

# Find packages
find_package(Qt5 ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS Core Concurrent Qml Quick Svg Sql QuickControls2 Xml Multimedia Positioning Location)
find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS KIO CoreAddons Kirigami2)
find_package(KQuickImageEditor REQUIRED)
find_package(KF5KirigamiAddons 0.7.0 REQUIRED)
find_package(ZXing REQUIRED)
find_package(QXmpp 1.5.0 REQUIRED COMPONENTS Omemo)

# Optional QtQuickCompiler
if(QUICK_COMPILER)
	find_package(Qt5QuickCompiler)
	set_package_properties(Qt5QuickCompiler PROPERTIES
		DESCRIPTION "Compile QML at build time"
		TYPE OPTIONAL
	)
endif()

if(USE_KNOTIFICATIONS)
	find_package(KF5Notifications REQUIRED)
	set(__KF5Notifications_LIBRARIES KF5::Notifications)
	add_definitions(-DHAVE_KNOTIFICATIONS)
endif()

# Optional QWidget style integration (not on mobile)
if(NOT UBUNTU_TOUCH AND NOT ANDROID AND NOT IOS)
	find_package(Qt5Widgets)
	find_package(KF5QQC2DesktopStyle)
	set_package_properties(Qt5Widgets PROPERTIES
		DESCRIPTION "Integration with QWidget based desktop styles"
		TYPE OPTIONAL
	)
endif()

# Platform-specific
if(Qt5Widgets_FOUND)
	add_definitions(-DHAVE_QWIDGETS -DQAPPLICATION_CLASS=QApplication)
	set(__Qt5Widgets_LIBRARIES Qt5::Widgets)
else()
	add_definitions(-DQAPPLICATION_CLASS=QGuiApplication)
endif()

if(ANDROID)
	find_package(Qt5 REQUIRED COMPONENTS AndroidExtras)
	# We need to link against sqlite3 to help androiddeployqt detect that we need it
	find_package(SQLite3 REQUIRED)

	find_package(PkgConfig REQUIRED)
	pkg_search_module(OPENSSL REQUIRED openssl IMPORTED_TARGET)
	message(STATUS "Using OpenSSL ${OPENSSL_VERSION}")
endif()

include(ECMPoQmTools)

ecm_install_po_files_as_qm(poqm)

#
# Kaidan binary
#

add_subdirectory(src)

#
# Install Kaidan
#

if(ANDROID)
	configure_file(${CMAKE_SOURCE_DIR}/misc/android/AndroidManifest.xml.in
	               ${CMAKE_SOURCE_DIR}/misc/android/AndroidManifest.xml)
elseif(IOS)
	configure_file(${CMAKE_SOURCE_DIR}/misc/ios/Info.plist.in
	               ${CMAKE_SOURCE_DIR}/misc/ios/Info.plist)
endif()

if(UBUNTU_TOUCH AND CLICK_ARCH)
	set(CLICK_VERSION ${VERSION_STRING})
	if(DEVELOPMENT_BUILD)
		set(CLICK_VERSION "${CLICK_VERSION}.${CLICK_DATE}")
	endif()

	# will replace ${CLICK_ARCH} with its value
	configure_file(${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json.in
	               ${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json)

	# install kaidan binary
	install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/bin/${PROJECT_NAME}
	        DESTINATION ${CMAKE_INSTALL_PREFIX}
	)
	# install kaidan media
	install(DIRECTORY "data/"
	        DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/${APPLICATION_ID}"
		PATTERN "*.qrc" EXCLUDE
	)
	# install icon
	install(FILES "data/images/kaidan.svg" "misc/ubuntu-touch/apparmor.json"
	              "misc/ubuntu-touch/kaidan.desktop" "misc/ubuntu-touch/manifest.json"
	        DESTINATION "${CMAKE_INSTALL_PREFIX}"
	)
elseif(UNIX AND NOT APPLE)
	# install kaidan media
	install(DIRECTORY "data/"
	        DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/${PROJECT_NAME}"
		PATTERN "*.qrc" EXCLUDE
	)

	# install icon (scalable + 128x)
	install(FILES "data/images/kaidan.svg"
	        DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/scalable/apps"
	)
	install(FILES "misc/kaidan-128x128.png"
	        DESTINATION "${CMAKE_INSTALL_FULL_DATADIR}/icons/hicolor/128x128/apps"
	        RENAME "kaidan.png"
	)
	# install desktop file
	install(FILES "misc/im.kaidan.kaidan.desktop"
	        DESTINATION "${KDE_INSTALL_APPDIR}"
	)
	# install metainfo
	install(FILES "misc/im.kaidan.kaidan.appdata.xml"
		DESTINATION "${KDE_INSTALL_METAINFODIR}"
		RENAME "${APPLICATION_ID}.appdata.xml"
	)
endif()

# install kaidan binary
install(TARGETS kaidan
        ${KDE_INSTALL_TARGETS_DEFAULT_ARGS}
)

# KNotifications
if(USE_KNOTIFICATIONS)
	install(FILES misc/kaidan.notifyrc DESTINATION ${KNOTIFYRC_INSTALL_DIR})
endif()

# Dev editable important files, to be seen in the IDE tree view
add_custom_target(Others
    SOURCES
		${CMAKE_SOURCE_DIR}/misc/im.kaidan.kaidan.desktop
		${CMAKE_SOURCE_DIR}/misc/im.kaidan.kaidan.appdata.xml
		${CMAKE_SOURCE_DIR}/misc/kaidan.notifyrc
		${CMAKE_SOURCE_DIR}/misc/android/AndroidManifest.xml.in
		${CMAKE_SOURCE_DIR}/misc/ios/Info.plist.in
		${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json.in
		${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/apparmor.json
		${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/kaidan.desktop
		${CMAKE_SOURCE_DIR}/misc/ubuntu-touch/manifest.json
)

#
# Unit tests
#

if(BUILD_TESTS)
	add_subdirectory(tests)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
#
# Sources / Resources
#

add_executable(${PROJECT_NAME} WIN32)

target_sources(${PROJECT_NAME} PRIVATE
	AbstractNotifier.h
	AccountManager.cpp
	AccountManager.h
	Algorithms.h
	AtmManager.cpp
	AtmManager.h
	AudioDeviceModel.cpp
	AudioDeviceModel.h
	AvatarFileStorage.cpp
	AvatarFileStorage.h
	BitsOfBinaryImageProvider.cpp
	BitsOfBinaryImageProvider.h
	CameraImageCapture.cpp
	CameraImageCapture.h
	CameraModel.cpp
	CameraModel.h
	ClientWorker.cpp
	ClientWorker.h
	CredentialsGenerator.cpp
	CredentialsGenerator.h
	CredentialsValidator.cpp
	CredentialsValidator.h
	DatabaseComponent.cpp
	DatabaseComponent.h
	Database.cpp
	Database.h
	DataFormModel.cpp
	DataFormModel.h
	DiscoveryManager.cpp
	DiscoveryManager.h
	EmojiModel.cpp
	EmojiModel.h
	Encryption.h
	Enums.h
	FileProgressCache.cpp
	FileProgressCache.h
	FileSharingController.cpp
	FileSharingController.h
	FutureUtils.h
	Globals.h
	GuiStyle.h
	# hsluv-c required for color generation
	hsluv-c/hsluv.c
	hsluv-c/hsluv.h
	OmemoCache.cpp
	OmemoCache.h
	OmemoWatcher.cpp
	OmemoWatcher.h

	JsonUtils.h
	Kaidan.cpp
	Kaidan.h
	LogHandler.cpp
	LogHandler.h
	main.cpp
	MediaRecorder.cpp
	MediaRecorder.h
	MediaSettingModel.h
	MediaSettings.cpp
	MediaSettings.h
	MediaUtils.cpp
	MediaUtils.h
	MessageComposition.cpp
	MessageComposition.h
	Message.cpp
	MessageDb.cpp
	MessageDb.h
	Message.h
	MessageHandler.cpp
	MessageHandler.h
	MessageModel.cpp
	MessageModel.h
	Notifications.cpp
	Notifications.h
	NotificationsMutedWatcher.cpp
	NotificationsMutedWatcher.h
	OmemoDb.cpp
	OmemoDb.h
	OmemoManager.cpp
	OmemoManager.h
	PresenceCache.cpp
	PresenceCache.h
	ProviderListItem.cpp
	ProviderListItem.h
	ProviderListModel.cpp
	ProviderListModel.h
	PublicGroupChat.cpp
	PublicGroupChat.h
	PublicGroupChatModel.cpp
	PublicGroupChatModel.h
	PublicGroupChatProxyModel.cpp
	PublicGroupChatProxyModel.h
	PublicGroupChatSearchManager.cpp
	PublicGroupChatSearchManager.h
	QmlUtils.cpp
	QmlUtils.h
	QrCodeDecoder.cpp
	QrCodeDecoder.h
	QrCodeGenerator.cpp
	QrCodeGenerator.h
	QrCodeScannerFilter.cpp
	QrCodeScannerFilter.h
	QrCodeVideoFrame.cpp
	QrCodeVideoFrame.h
	# kaidan QXmpp extensions (need to be merged into QXmpp upstream)
	qxmpp-exts/QXmppColorGenerator.cpp
	qxmpp-exts/QXmppColorGenerator.h
	qxmpp-exts/QXmppUri.cpp
	qxmpp-exts/QXmppUri.h
	RecentPicturesModel.cpp
	RecentPicturesModel.h
	RegistrationDataFormFilterModel.cpp
	RegistrationDataFormFilterModel.h
	RegistrationDataFormModel.cpp
	RegistrationDataFormModel.h
	RegistrationManager.cpp
	RegistrationManager.h
	RosterDb.cpp
	RosterDb.h
	RosterFilterProxyModel.cpp
	RosterFilterProxyModel.h
	RosterItem.cpp
	RosterItem.h
	RosterItemWatcher.cpp
	RosterItemWatcher.h
	RosterManager.cpp
	RosterManager.h
	RosterModel.cpp
	RosterModel.h
	ServerFeaturesCache.cpp
	ServerFeaturesCache.h
	Settings.cpp
	Settings.h
	SqlUtils.cpp
	SqlUtils.h
	static_plugins.h
	StatusBar.cpp
	StatusBar.h
	TrustDb.cpp
	TrustDb.h
	UserDevicesModel.cpp
	UserDevicesModel.h
	VCardCache.cpp
	VCardCache.h
	VCardManager.cpp
	VCardManager.h
	VCardModel.cpp
	VCardModel.h
	VersionManager.cpp
	VersionManager.h

	${CMAKE_SOURCE_DIR}/data/data.qrc
	${CMAKE_SOURCE_DIR}/misc/misc.qrc
)

if(NOT ANDROID AND NOT IOS)
	target_sources(${PROJECT_NAME} PRIVATE
		singleapp/singleapplication.cpp
		singleapp/singleapplication.h
		singleapp/singleapplication_p.cpp
		singleapp/singleapplication_p.h
	)
endif()

# Include bundled icons on Ubuntu Touch, Android, Windows, macOS and iOS
if(BUNDLE_ICONS OR UBUNTU_TOUCH OR ANDROID)
	target_sources(${PROJECT_NAME} PRIVATE "${CMAKE_SOURCE_DIR}/kirigami-icons.qrc")
endif()

# Bundled knotifications configuration files on platforms that require it
if(ANDROID)
	target_sources(${PROJECT_NAME} PRIVATE "${CMAKE_SOURCE_DIR}/misc/notifications.qrc")
endif()

# Bundle images on Android, Windows, macOS and iOS
if(ANDROID OR WIN32 OR APPLE)
	target_sources(${PROJECT_NAME} PRIVATE "${CMAKE_SOURCE_DIR}/data/images/images.qrc")
endif()

# Set app icon
include(ECMAddAppIcon)
file(GLOB ICONS_SRCS "${CMAKE_SOURCE_DIR}/misc/app-icons/*kaidan.png")
message(STATUS ${ICONS_SRCS})
ecm_add_app_icon(KAIDAN_ICNS ICONS ${ICONS_SRCS})
message(STATUS ${KAIDAN_ICNS})
target_sources(${PROJECT_NAME} PRIVATE ${KAIDAN_ICNS})

# QML files
if(QUICK_COMPILER)
	qtquick_compiler_add_resources(COMPILED_QML_QRC qml/qml.qrc)
	target_sources(${PROJECT_NAME} PRIVATE ${COMPILED_QML_QRC})
else()
	target_sources(${PROJECT_NAME} PRIVATE qml/qml.qrc)
endif()

ecm_create_qm_loader(${PROJECT_NAME} kaidan_qt)

target_link_libraries(${PROJECT_NAME}
	Qt::Core
	Qt::Sql
	Qt::Qml
	Qt::Quick
	Qt::Svg
	Qt::Network
	Qt::Xml
	Qt::Multimedia
	Qt::Positioning
	Qt::Location
	Qt::QuickControls2
	KF5::CoreAddons
	KF5::KIOFileWidgets
	QXmpp::QXmpp QXmpp::Omemo
	${__Qt5Widgets_LIBRARIES}
	${__KF5Notifications_LIBRARIES}
)

if(TARGET ZXing::ZXing)
        target_link_libraries(${PROJECT_NAME} ZXing::ZXing)
elseif(TARGET ZXing::Core)
        target_link_libraries(${PROJECT_NAME} ZXing::Core)
endif()

if(ANDROID OR IOS)
	target_link_libraries(${PROJECT_NAME} Qt5::QuickControls2 KF5::Kirigami2)
endif()

if(ANDROID)
	target_link_libraries(${PROJECT_NAME} PkgConfig::OPENSSL SQLite::SQLite3 Qt5::AndroidExtras)
endif()

if(STATIC_BUILD)
	add_definitions(-DQXMPP_BUILD)

	find_package(Perl REQUIRED)

	set(STATIC_DEPENDENCIES_CMAKE_FILE "${CMAKE_BINARY_DIR}/QtStaticDependencies.cmake")
	if(EXISTS ${STATIC_DEPENDENCIES_CMAKE_FILE})
		file(REMOVE ${STATIC_DEPENDENCIES_CMAKE_FILE})
	endif()

	get_target_property(QT_LIBDIR Qt5::Core LOCATION)
	get_filename_component(QT_LIBDIR ${QT_LIBDIR} DIRECTORY)

	macro(CONVERT_PRL_LIBS_TO_CMAKE _qt_component)
		if(TARGET Qt5::${_qt_component})
			get_target_property(_lib_location Qt5::${_qt_component} LOCATION)
			execute_process(COMMAND ${PERL_EXECUTABLE} ${CMAKE_SOURCE_DIR}/utils/convert-prl-libs-to-cmake.pl
				--lib ${_lib_location}
				--libdir ${QT_LIBDIR}
				--out ${STATIC_DEPENDENCIES_CMAKE_FILE}
				--component ${_qt_component}
				--compiler ${CMAKE_CXX_COMPILER_ID}
			)
		endif()
	endmacro()

	link_directories(${_qt5_install_prefix}/../)

	foreach(qt_module Gui Quick QuickControls2 Network Qml Svg Sql QSQLiteDriverPlugin
             QJpegPlugin QGifPlugin QSvgPlugin QSvgIconPlugin QICOPlugin QGenericEnginePlugin
	         QLocalClientConnectionFactory QTcpServerConnectionFactory)
		CONVERT_PRL_LIBS_TO_CMAKE(${qt_module})
	endforeach()

	if(IOS)
		foreach(qt_module QIOSIntegrationPlugin QMacHeifPlugin QMacJp2Plugin
			QICNSPlugin QTgaPlugin QTiffPlugin QWbmpPlugin QWebpPlugin)
			CONVERT_PRL_LIBS_TO_CMAKE(${qt_module})
		endforeach()
	endif()

	if(NOT EXISTS ${STATIC_DEPENDENCIES_CMAKE_FILE})
		message(FATAL_ERROR "Unable to find ${STATIC_DEPENDENCIES_CMAKE_FILE}")
	endif()
	include(${STATIC_DEPENDENCIES_CMAKE_FILE})

	set(QT_QML_PATH ${_qt5Quick_install_prefix})

	find_library(KIRIGAMI_PLUGIN kirigamiplugin PATHS ${Kirigami2_INSTALL_PREFIX}/${KDE_INSTALL_QMLDIR}/org/kde/kirigami.2)
	find_library(QUICK_PLUGIN qtquick2plugin PATHS ${QT_QML_PATH}/qml/QtQuick.2)
	find_library(LABS_PLATFORM_PLUGIN qtlabsplatformplugin PATHS ${QT_QML_PATH}/qml/Qt/labs/platform)
	find_library(GRAPHEFFECTS_PLUGIN qtgraphicaleffectsplugin PATHS ${QT_QML_PATH}/qml/QtGraphicalEffects)
	find_library(GRAPHEFFECTS_PRIVATE_PLUGIN qtgraphicaleffectsprivate PATHS ${QT_QML_PATH}/qml/QtGraphicalEffects/private)
	find_library(QQC2_PLUGIN qtquickcontrols2plugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2)
	find_library(QQC2_MATERIAL_PLUGIN qtquickcontrols2materialstyleplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2/Material)
	find_library(QQC2_UNIVERSAL_PLUGIN qtquickcontrols2universalstyleplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Controls.2/Universal)
	find_library(QLAYOUTS_PLUGIN qquicklayoutsplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Layouts)
	find_library(QWINDOW_PLUGIN windowplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Window.2)
	find_library(QSHAPES_PLUGIN qmlshapesplugin PATHS ${QT_QML_PATH}/qml/QtQuick/Shapes)
	find_library(QUICKSHAPES Qt5QuickShapes PATHS ${QT_LIBDIR})
	find_library(QTEMPLATES_PLUGIN qtquicktemplates2plugin PATHS ${QT_QML_PATH}/qml/QtQuick/Templates.2)
	find_library(QMODELS_PLUGIN modelsplugin PATHS ${QT_QML_PATH}/qml/QtQml/Models.2)
	target_link_libraries(${PROJECT_NAME}
		${plugin_libs}
		Qt5::QSQLiteDriverPlugin
		Qt5::QJpegPlugin
		Qt5::QGifPlugin
		Qt5::QSvgPlugin
		Qt5::QSvgIconPlugin
		Qt5::QICOPlugin
		Qt5::QGenericEnginePlugin
		Qt5::QLocalClientConnectionFactory
		Qt5::QTcpServerConnectionFactory
		${KIRIGAMI_PLUGIN}
		${QUICK_PLUGIN}
		${LABS_PLATFORM_PLUGIN}
		${GRAPHEFFECTS_PLUGIN}
		${GRAPHEFFECTS_PRIVATE_PLUGIN}
		${QQC2_PLUGIN}
		${QQC2_MATERIAL_PLUGIN}
		${QQC2_UNIVERSAL_PLUGIN}
		${QLAYOUTS_PLUGIN}
		${QWINDOW_PLUGIN}
		${QSHAPES_PLUGIN}
		${QUICKSHAPES}
		${QTEMPLATES_PLUGIN}
		${QMODELS_PLUGIN}
		${__Qt5Widgets_LIBRARIES}
	)

	if(IOS)
		target_link_libraries(${PROJECT_NAME}
			Qt5::QIOSIntegrationPlugin
			Qt5::QMacHeifPlugin
			Qt5::QMacJp2Plugin
			Qt5::QICNSPlugin
			Qt5::QTgaPlugin
			Qt5::QTiffPlugin
			Qt5::QWbmpPlugin
			Qt5::QWebpPlugin
		)
	endif()
endif()

# Set a custom plist file for the app bundle
if(APPLE)
	if(IOS)
		set_target_properties(${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/misc/ios/Info.plist)
	else()
		set_target_properties(${PROJECT_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_SOURCE_DIR}/misc/macos/Info.plist)
	endif()
endif()

# iOS-specific linker flags
if(IOS)
	set(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} "-Wl,-e,_qt_main_wrapper -u _qt_registerPlatformPlugin")
endif()

#
# Global C++ definitions
#

if(UBUNTU_TOUCH)
	target_compile_definitions(${PROJECT_NAME} PRIVATE UBUNTU_TOUCH=True)
elseif(APPIMAGE)
	target_compile_definitions(${PROJECT_NAME} PRIVATE
		APPIMAGE=True
		TARGET_GSTREAMER_PLUGINS="${TARGET_GSTREAMER_PLUGINS}"
	)
endif()

if(STATIC_BUILD)
	target_compile_definitions(${PROJECT_NAME} PRIVATE
		STATIC_BUILD=True
	)
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE
	QXMPP_DISABLE_DEPRECATED_BEFORE=0x010400
	QT_DISABLE_DEPRECATED_BEFORE=0x050F00
	DEBUG_SOURCE_PATH="${CMAKE_SOURCE_DIR}"
	VERSION_STRING="${VERSION_STRING}"
	APPLICATION_ID="${APPLICATION_ID}"
	APPLICATION_NAME="${APPLICATION_NAME}"
	APPLICATION_DISPLAY_NAME="${APPLICATION_DISPLAY_NAME}"
	APPLICATION_DESCRIPTION="${APPLICATION_DESCRIPTION}"
)

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2020 Linus Jahn <lnj@kaidan.im>
#
# SPDX-License-Identifier: CC0-1.0

include(ECMAddTests)

find_package(Qt5Test REQUIRED)

ecm_add_test(
	PresenceCacheTest.cpp
	../src/PresenceCache.cpp
	../src/PresenceCache.h
	TEST_NAME PresenceCacheTest
	LINK_LIBRARIES Qt::Test Qt::Gui QXmpp::QXmpp
)

ecm_add_test(
	RosterItemWatcherTest.cpp
	../src/RosterItemWatcher.cpp
	../src/RosterItemWatcher.h
	../src/RosterItem.cpp
	../src/RosterItem.h
	TEST_NAME RosterItemWatcherTest
	LINK_LIBRARIES Qt::Test Qt::Gui QXmpp::QXmpp
)
target_compile_definitions(RosterItemWatcherTest PUBLIC UNIT_TEST)

ecm_add_test(
	UserPresenceWatcherTest.cpp
	../src/PresenceCache.cpp
	../src/PresenceCache.h
	TEST_NAME UserPresenceWatcherTest
	LINK_LIBRARIES Qt::Test Qt::Gui QXmpp::QXmpp
)

ecm_add_test(
	TrustDbTest.cpp
	utils.h
	../src/Database.cpp
	../src/Database.h
	../src/DatabaseComponent.cpp
	../src/DatabaseComponent.h
	../src/SqlUtils.cpp
	../src/SqlUtils.h
	../src/TrustDb.cpp
	../src/TrustDb.h
	TEST_NAME TrustDbTest
	LINK_LIBRARIES Qt::Test Qt::Gui Qt::Sql QXmpp::QXmpp
)
target_compile_definitions(TrustDbTest PUBLIC DB_UNIT_TEST)

ecm_add_test(
	OmemoDbTest.cpp
	utils.h
	../src/Database.cpp
	../src/Database.h
	../src/DatabaseComponent.cpp
	../src/DatabaseComponent.h
	../src/SqlUtils.cpp
	../src/SqlUtils.h
	../src/OmemoDb.cpp
	../src/OmemoDb.h
	TEST_NAME OmemoDbTest
	LINK_LIBRARIES Qt::Test Qt::Gui Qt::Sql QXmpp::QXmpp QXmpp::Omemo
)
target_compile_definitions(OmemoDbTest PUBLIC DB_UNIT_TEST)

ecm_add_test(
	PublicGroupChatTest.cpp
	../src/PublicGroupChat.cpp
	../src/PublicGroupChat.h
	../src/PublicGroupChatModel.cpp
	../src/PublicGroupChatModel.h
	../src/PublicGroupChatProxyModel.cpp
	../src/PublicGroupChatProxyModel.h
	../src/PublicGroupChatSearchManager.cpp
	../src/PublicGroupChatSearchManager.h
	TEST_NAME PublicGroupChatTest
	LINK_LIBRARIES Qt::Test Qt::Network
)

# Manual tests

add_executable(PublicGroupChatSearch
	manual/public-group-chat-search.cpp
)
target_link_libraries(PublicGroupChatSearch
	PRIVATE
		Qt::Core Qt::Network
)

=== debian/changelog ===
kaidan (0.9.1-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:58:31 +1100

kaidan (0.9.1-3build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 04:41:23 +0000

kaidan (0.9.1-3) unstable; urgency=medium

  * Team upload.
  * Disable the test test_GroupChatSearchManager_GroupChatModel, as it requires
    an Internet connectivity. (Closes: #1056583)

 -- Pino Toscano <pino@debian.org>  Sat, 16 Dec 2023 14:05:45 +0100

kaidan (0.9.1-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * Add missing runtime dependencies:
    qml-module-org-kde-kirigami-addons-labs-mobileform, and
    qml-module-org-kde-kquickimageeditor. (Closes: #1055880)
  * Switch Vcs-* fields back to the 'master' packaging branch.

 -- Pino Toscano <pino@debian.org>  Fri, 17 Nov 2023 09:42:00 +0100

kaidan (0.9.1-1) experimental; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #1036558)
  * Switch Vcs-* fields to the 'experimental' packaging branch.
  * Update build dependencies according to the upstream build system:
    - bump cmake to 3.16
    - bump Qt packages to 5.15.0
    - switch libqxmpp-dev to libqxmppqt5-dev, and bump it to 1.5.0 (to the
      actual version with OMEMO support)
    - add kirigami-addons-dev, kquickimageeditor-dev, libkf5coreaddons-dev,
      and libkf5kio-dev
  * Bump Qt dependencies to 5.15.0
  * Drop the -DI18N=TRUE cmake parameter, as translations are built
    unconditionally now.
  * Pass -DBUILD_TESTS=TRUE to cmake to build & run the unit tests at build
    time.

 -- Pino Toscano <pino@debian.org>  Sun, 12 Nov 2023 16:12:00 +0100

kaidan (0.8.0-3) unstable; urgency=medium

  * Team upload.
  * Update standards version to 4.6.2, no changes needed.
  * Replace the transitional libzxingcore-dev build dependency with
    libzxing-dev. (Closes: #1054383)
  * Update watch file.

 -- Pino Toscano <pino@debian.org>  Sat, 11 Nov 2023 21:03:07 +0100

=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.40.0~),
               kirigami-addons-dev (>= 0.7.0~),
               kquickimageeditor-dev,
               libgstreamer1.0-dev,
               libkf5coreaddons-dev (>= 5.67.0~),
               libkf5kio-dev (>= 5.67.0~),
               libkf5notifications-dev (>= 5.67.0~),
               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
               libqxmppqt5-dev (>= 1.5.5-0.2~),
               libqt5svg5-dev (>= 5.15.0~),
               libzxing-dev,
               kirigami2-dev (>= 5.67.0~),
               pkg-kde-tools,
               qtbase5-dev (>= 5.15.0~),
               qtlocation5-dev (>= 5.15.0~),
               qtmultimedia5-dev (>= 5.15.0~),
               qtpositioning5-dev (>= 5.15.0~),
               qtquickcontrols2-5-dev (>= 5.15.0~),
               qttools5-dev (>= 5.15.0~),
Standards-Version: 4.6.2
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: qml-module-org-kde-kirigami2 (>= 5.67.0~),
         qml-module-org-kde-kirigami-addons-labs-mobileform,
         qml-module-org-kde-kquickimageeditor,
         qml-module-org-kde-qqc2desktopstyle (>= 5.67.0~),
         qml-module-qtgraphicaleffects (>= 5.15.0~),
         qml-module-qtlocation (>= 5.15.0~),
         qml-module-qtmultimedia (>= 5.15.0~),
         qml-module-qtpositioning (>= 5.15.0~),
         qml-module-qtqml (>= 5.15.0~),
         qml-module-qtquick-controls2 (>= 5.15.0~),
         qml-module-qtquick-dialogs (>= 5.15.0~),
         qml-module-qtquick-layouts (>= 5.15.0~),
         qml-module-qtquick2 (>= 5.15.0~),
         ${shlibs:Depends},
         ${misc:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTS=TRUE

## kaidan 0.9.2

=== debian/changelog ===
kaidan (0.9.2-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Update watch file.
  * Add/update Melvin Keskin’s key in upstream keyring.
  * New upstream release (0.9.2).
  * Update build-deps and deps with the info from cmake.
  * Switch to declarative KF5 debhelper build sequence.
  * Switch to dh_qmldeps for runtime QML dependencies.
  * Add missing overrides and qml dependencies for dh_qmldeps.
  * Bump Standards-Version to 4.7.0, no change required.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sat, 07 Dec 2024 23:35:04 +0100

kaidan (0.9.1-4) unstable; urgency=medium

  [ Patrick Franz ]
  * Team upload.
  * Switch kirigami-addons-dev B-D to kirigami-addons5-dev.

 -- Patrick Franz <deltaone@debian.org>  Fri, 23 Aug 2024 18:08:20 +0200

=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf5,
               dh-sequence-qmldeps,
               extra-cmake-modules (>= 5.40.0~),
               kirigami-addons-dev (>= 0.7.0~),
               kirigami-addons5-dev (>= 0.7.0~),
               kirigami2-dev (>= 5.67.0~),
               kquickimageeditor-dev,
               libgstreamer1.0-dev,
               libkf5coreaddons-dev (>= 5.67.0~),
               libkf5kio-dev (>= 5.67.0~),
               libkf5notifications-dev (>= 5.67.0~),
               libkf5qqc2desktopstyle-dev (>= 5.67.0~),
               libqt5svg5-dev (>= 5.15.0~),
               libqxmppqt5-dev (>= 1.5.5-0.2~),
               libsqlite3-dev,
               libzxing-dev,
               perl,
               pkg-kde-tools (>= 0.18.9~),
               pkgconf,
               qml-module-qtlocation,
               qml-module-qtpositioning,
               qml-module-qtquick-dialogs,
               qtbase5-dev (>= 5.15.0~),
               qtdeclarative5-dev (>= 5.15.0~),
               qtdeclarative5-dev-tools,
               qtlocation5-dev (>= 5.15.0~),
               qtmultimedia5-dev (>= 5.15.0~),
               qtpositioning5-dev (>= 5.15.0~),
               qtquickcontrols2-5-dev (>= 5.15.0~),
               qttools5-dev (>= 5.15.0~),
Standards-Version: 4.7.0
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: ${qml5:Depends},
         ${misc:Depends},
         ${shlibs:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTS=TRUE

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/unstable/@PACKAGE@/([\d.]+)/@PACKAGE@-([\d.]+)\.tar\.xz

## kaidan 0.11.0

=== debian/changelog ===
kaidan (0.11.0-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (0.11.0). (Closes: #1089817, #1090237, #998674)
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Refresh patches.
  * Disable build-time tests which really don’t look ready for prime
    time.
  * Review copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 23 Feb 2025 22:54:58 +0100

=== debian/control ===
Source: kaidan
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@alioth-lists.debian.net>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-qmldeps,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.6.0~),
               kirigami-addons-dev (>= 1.4.0~),
               kquickimageeditor-dev,
               libgstreamer1.0-dev,
               libicu-dev (>= 61.0~),
               libkf6crash-dev (>= 6.6.0~),
               libkf6kio-dev (>= 6.6.0~),
               libkf6notifications-dev (>= 6.6.0~),
               libkf6prison-dev (>= 6.6.0~),
               libkf6qqc2desktopstyle-dev,
               libkirigami-dev (>= 6.6.0~),
               libqxmppqt6-dev (>= 1.9.0~),
               libsqlite3-dev,
               libssl-dev (>= 1.1~),
               libzxing-dev,
               perl,
               pkg-kde-tools (>= 0.18.9~),
               pkgconf,
               qt6-base-dev (>= 6.6.0~),
               qt6-declarative-dev (>= 6.6.0~),
               qt6-declarative-private-dev,
               qt6-location-dev (>= 6.6.0~),
               qt6-multimedia-dev (>= 6.6.0~),
               qt6-positioning-dev (>= 6.6.0~),
               qt6-svg-dev (>= 6.6.0~),
Standards-Version: 4.7.0
Homepage: https://www.kaidan.im/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kaidan
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kaidan.git
Rules-Requires-Root: no

Package: kaidan
Architecture: any
Depends: ${misc:Depends}, ${qml6:Depends}, ${shlibs:Depends},
Description: Simple and user-friendly Jabber/XMPP client
 Kaidan is a simple, user-friendly and modern chat client. It uses the open
 communication protocol XMPP (Jabber).
 .
 The user interface makes use of Kirigami and QtQuick, while the back-end of
 Kaidan is entirely written in C++ using Qt and the Qt-based XMPP library
 QXmpp.

## kaidan 0.12.0

=== debian/changelog ===
kaidan (0.12.0-2) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * Add patch to fix crash on initial account login.

 -- Aurélien COUDERC <coucouf@debian.org>  Tue, 25 Mar 2025 13:20:13 +0100

kaidan (0.12.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * There is no more embedded copy of singleapp to exclude from the sources,
    so simplify the packaging:
    - drop the +dfsg suffix from the version number
    - in the watch file, drop the repacking & the +dfsg suffix
    - drop the exclusions from debian/copyright
  * Update the patches:
    - upstream_appdata-fix-ID-in-translation.patch: drop, backported from
      upstream
    - upstream_Replace-SingleApplication-with-KDSingleApplication.patch: drop,
      backported from upstream
    - tests-no-network.diff: refresh
  * Update the build dependencies according to the upstream build system:
    - bump KF packages to 6.11.0
    - bump libqxmppqt6-dev to 1.10.3
  * Concatenate all the keys in debian/upstream/signing-key.asc.
  * Small updates to debian/copyright.

 -- Pino Toscano <pino@debian.org>  Mon, 24 Mar 2025 22:51:32 +0100

kaidan (0.11.0+dfsg-1) unstable; urgency=medium

  * Team upload.
  * Backport upstream commit 21ac9c2abe73115149614c3f09ed5154371de2a6 to fix
    the <translation> tag in AppStream XML metadata; patch
    upstream_appdata-fix-ID-in-translation.patch.
  * Bump Standards-Version to 4.7.2, no changes required.
  * Update build dependencies according to the upstream build system:
    - add qml6-module-org-kde-kquickimageeditor as QML dependency
    - drop pkg-kde-tools, used via dh-sequence-*
    - drop no more used, or not used for Debian platforms:
      kquickimageeditor-dev, libgstreamer1.0-dev, libsqlite3-dev, libssl-dev,
      libzxing-dev, perl, and pkgconf
  * Replace the embedded copy of singleapp with the usage of an external
    KDSingleApplication, as newer versions of singleapp have non-free clauses:
    (Closes: #1099531)
    - ensure to not have the non-free sources, and thus repack them:
      - add a +dfsg suffix to the version number
      - adapt the watch file for repacking and the +dfsg suffix
      - exclude the 'src/singleapp' subdirectory via debian/copyright
      - disable the GPG  signing verification, since the tarball is now repacked
    - backport part of upstream commit 516f4ddc8a57e8980affabab7237064b70ecaf81
      to use KDSingleApplication; patch
      upstream_Replace-SingleApplication-with-KDSingleApplication.patch
    - add new build dependencies needed because of the changes:
      qt6-base-private-dev, libkdsingleapplication-qt6-dev, and
      libkf6windowsystem-dev

 -- Pino Toscano <pino@debian.org>  Sun, 16 Mar 2025 11:11:44 +0100
